
$(function() {

var recording = false;
var macro;

var signalarray = ['ZERO', 'ONE', 'TWO', 'THREE', 'FOUR',
		   'FIVE', 'SIX', 'SEVEN', 'EIGHT', 'NINE'];

$('button').button();

var refreshIntervalId = false;
function refreshstatus(show)
{
	if (show)
		$('#irboxstatus').empty().html(
		    '<img src=/img/loading.gif>Loading...');
	$('#irboxstatus').load('/cgi-bin/status.jim');

	if (!refreshIntervalId)
		refreshIntervalId = setInterval(refreshstatus, 30000);
}

function forcerefreshstatus()
{
	if (refreshIntervalId)
	{
		clearInterval(refreshIntervalId);
		refreshIntervalId = false;
	}
	$('#irboxstatus').empty().html('<img src=/img/loading.gif>Loading...');
	setTimeout(refreshstatus, 3000);
}

refreshstatus(false);

function dot($area)
{
	coords = $area.attr('coords').split(',');
	if (!coords)
		return;
	if ($area.attr('shape') == 'circle')
	{
		var rad = coords[2];
		var width = rad * 2;
		var height = rad * 2;
		var left = coords[0] - rad;
		var top = coords[1] - rad;
	}
	else
	{
		var width = coords[2] - coords[0];
		var height = coords[3] - coords[1];
		var left = coords[0];
		var top = coords[1];
	}
	$('#dot')
		.stop(true, true)
		.css('width', width + 'px')
		.css('height', height + 'px')
		.css('left', left + 'px')
		.css('top', top + 'px')
		.fadeIn('fast').delay(300).fadeOut('fast');
}

function send(cmd, xmit, callback)
{
	$(xmit).stop(true, true).fadeIn('fast').delay(300).fadeOut('fast');
	$.get('send.jim?code=' + cmd, function(ret) {
		$('#output').slideDown();
		$('#results').append(ret + '<br>');
		if (callback)
			callback();
	});
}

function sendK(cmd, xmit, callback)
{
	dot($('area[code="' + cmd + '"]'));
	send(encodeURIComponent(cmd), '#xmit' + xmit, callback);
}

$(document).keydown(function(e) {
	if (recording)
		return;

	if (e.keyCode == 38)
		sendK(e.shiftKey ? 'P+' : 'UP', 2);
	else if (e.keyCode == 40)
		sendK(e.shiftKey ? 'P-' : 'DOWN', 2);
	else if (e.keyCode == 37) { // left
		if (e.shiftKey)
			sendK('REW', 1);
		else if(e.ctrlKey)
			sendK('SKIP/BACK', 1);
		else
			sendK('LEFT', 2);
	}
	else if (e.keyCode == 39) { // right
		if (e.shiftKey)
			sendK('FF', 1);
		else if(e.ctrlKey)
			sendK('SKIP/FORW', 1);
		else
			sendK('RIGHT', 2);
	}
	else if (e.keyCode == 13)	// return
		sendK('OK', 2, function() { forcerefreshstatus(); });
	else if (e.keyCode == 32) // space
		sendK('PAUSE', 1);
	else if (e.keyCode == 73) // i
		sendK('INFO', 2);
	else if (e.keyCode == 76) // l
		sendK('LIST', 2);
	else if (e.keyCode == 77) // m
		sendK('MUTE', 1);
	else if (e.keyCode == 80) // p
		sendK('PLAY', 1);
	else if (e.keyCode == 83) // s
		sendK('STOP', 1);
	else if (e.keyCode == 85) // u
		sendK('MENU', 1);
	else if (e.keyCode == 27) // ESC
		sendK(e.shiftKey ? 'EXIT' : 'BACK', 2);
	else if (e.keyCode == 112) // F1
		sendK('MEDIA', 2);
	else if (e.keyCode == 113) // F2
		sendK('GUIDE', 2);
	else if (e.keyCode == 9) // TAB
		sendK('OPT+', 2);
	else if (e.keyCode == 219) // [
		sendK('VOL-', 2);
	else if (e.keyCode == 221) // ]
		sendK('VOL+', 2);
	//  4 adjacent keys represent the colours...
	else if (e.keyCode == 81) // q
		sendK('RED', 1);
	else if (e.keyCode == 87) // w
		sendK('GREEN', 1);
	else if (e.keyCode == 69) // e
		sendK('YELLOW', 1);
	else if (e.keyCode == 82) // r
		sendK('BLUE', 1);
	else if (e.keyCode==66) // b/B
		sendK(e.shiftKey ? 'ADDBOOKMARK' : 'BOOKMARKS', 2);
	//  number keys (not number pad)...
	else if (e.keyCode >= 48 && e.keyCode <= 57)
		sendK(signalarray[e.keyCode - 48], 1);
	//  number pad numbers...
	else if (e.keyCode >= 96 && e.keyCode <= 105)
		sendK(signalarray[e.keyCode-96], 1);
	else
		return;

	// If key was handled
	e.preventDefault();
});

$('#clearhistory').click(function(e) {
	e.preventDefault();
	$('#output').slideUp();
	$('#results').empty();
});

$('area').click(function() {
	var code = $(this).attr('code');
	var x = $(this).attr('xmit');

	if (recording)
	{
		if (macro == '')
			macro = code;
		else
			macro = macro + ' ' + code;
		$('#newmacro').text(macro);
		$('#macroname').trigger('keyup');
		return;
	}

	if (code == 'STANDBY' && !confirm(
	    'Caution: If you put the machine into standby remotely, ' +
	    'you will not be able to restart it remotely. Are you sure?'))
		return false;

	dot($(this));

	if (code == 'OK')
		send(encodeURIComponent(code), '#xmit' + x,
		    function() { forcerefreshstatus(); });
	else
		send(encodeURIComponent(code), '#xmit' + x);

	return false;
});

function banner(msg)
{
	$('#banner').empty().html(msg)
	    .slideDown('slow').delay(1000).slideUp('slow');
}

function changechannel(lcn)
{
	var cmd = '';
	for (i = 0; i < lcn.length; i++)
	{
		if (i > 0)
			cmd += '+';
		cmd += signalarray[lcn.charAt(i)];
	}
	if (lcn < 1000)
		cmd += '+OK';
	//console.log('LCN: %O', lcn);
	//console.log('CMD: %O', cmd);

	banner('Changing to channel ' + lcn);
	send(cmd, '#xmit1,#xmit2', function() { forcerefreshstatus(); });
}

$('#dcselect').change(function() {
	var lcn = $(this).find('option:selected').val();
	changechannel(lcn);
});

$('#choosechannels').click(function(e) {
	window.location.href = '/plugin/ir/settings.jim';
});

$('.favchan').click(function(e) {
	e.preventDefault();
	changechannel($(this).attr('lcn'));
});

$('#m_record').click(function() {
	macro = '';
	recording = true;
	$('#delaybuttons').show('slow');
	$('#stoprecording').disable();
	$('#macroname').val('');
	$('#newmacro').empty();
	$('#recordingmacro').slideDown();
});

$('#macroname').keyup(function() {
	if ($(this).val().length > 0 && macro.length)
		$('#stoprecording').enable();
	else
		$('#stoprecording').disable();
});

$('#stoprecording').click(function() {
	$('button').disable();
	$.get('savemacro.jim?name=' +
	    encodeURIComponent($('#macroname').val()) + 
	    '&code=' + encodeURIComponent(macro),
	    function() { window.location.reload(true); });
});

$('#cancelrecording').click(function() {
	recording = false;
	$('#recordingmacro').slideUp('fast');
	$('#delaybuttons').hide('slow');
});

$('button.macroexec').click(function() {
	banner('Sending macro.');
	send(encodeURIComponent($(this).attr('code')), '#xmit1,#xmit2',
	    function() { forcerefreshstatus(); });
});

$('a.macrodelete').click(function(e) {
	e.preventDefault();
	var name = $(this).attr('xname');
	if (!confirm('Are you sure you want to remove macro "' +
	    name.substr(13) + '"?'))
		return;
	$.get('deletemacro.jim?name=' + encodeURIComponent(name),
	    function() {
		$('#macrospan_' + name).hide('slow').remove();
	    }
	);
});

$('#smssend').click(function() {
	var text = $('#smsinput').val();
	if (!text.length)
		return;

	banner('Sending SMS text.');

	send(encodeURIComponent('!' + text), '#xmit1');
});

});

